# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulpcore.configuration import Configuration


class OpenPGPPublicKeyResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pulp_href': 'str',
        'prn': 'str',
        'pulp_created': 'datetime',
        'pulp_last_updated': 'datetime',
        'fingerprint': 'str',
        'created': 'datetime',
        'user_ids': 'list[NestedOpenPGPUserIDResponse]',
        'user_attributes': 'list[NestedOpenPGPUserAttributeResponse]',
        'public_subkeys': 'list[NestedOpenPGPPublicSubkeyResponse]'
    }

    attribute_map = {
        'pulp_href': 'pulp_href',
        'prn': 'prn',
        'pulp_created': 'pulp_created',
        'pulp_last_updated': 'pulp_last_updated',
        'fingerprint': 'fingerprint',
        'created': 'created',
        'user_ids': 'user_ids',
        'user_attributes': 'user_attributes',
        'public_subkeys': 'public_subkeys'
    }

    def __init__(self, pulp_href=None, prn=None, pulp_created=None, pulp_last_updated=None, fingerprint=None, created=None, user_ids=None, user_attributes=None, public_subkeys=None, local_vars_configuration=None):  # noqa: E501
        """OpenPGPPublicKeyResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._pulp_href = None
        self._prn = None
        self._pulp_created = None
        self._pulp_last_updated = None
        self._fingerprint = None
        self._created = None
        self._user_ids = None
        self._user_attributes = None
        self._public_subkeys = None
        self.discriminator = None

        if pulp_href is not None:
            self.pulp_href = pulp_href
        if prn is not None:
            self.prn = prn
        if pulp_created is not None:
            self.pulp_created = pulp_created
        if pulp_last_updated is not None:
            self.pulp_last_updated = pulp_last_updated
        if fingerprint is not None:
            self.fingerprint = fingerprint
        if created is not None:
            self.created = created
        if user_ids is not None:
            self.user_ids = user_ids
        if user_attributes is not None:
            self.user_attributes = user_attributes
        if public_subkeys is not None:
            self.public_subkeys = public_subkeys

    @property
    def pulp_href(self):
        """Gets the pulp_href of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The pulp_href of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._pulp_href

    @pulp_href.setter
    def pulp_href(self, pulp_href):
        """Sets the pulp_href of this OpenPGPPublicKeyResponse.


        :param pulp_href: The pulp_href of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: str
        """

        self._pulp_href = pulp_href

    @property
    def prn(self):
        """Gets the prn of this OpenPGPPublicKeyResponse.  # noqa: E501

        The Pulp Resource Name (PRN).  # noqa: E501

        :return: The prn of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._prn

    @prn.setter
    def prn(self, prn):
        """Sets the prn of this OpenPGPPublicKeyResponse.

        The Pulp Resource Name (PRN).  # noqa: E501

        :param prn: The prn of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: str
        """

        self._prn = prn

    @property
    def pulp_created(self):
        """Gets the pulp_created of this OpenPGPPublicKeyResponse.  # noqa: E501

        Timestamp of creation.  # noqa: E501

        :return: The pulp_created of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_created

    @pulp_created.setter
    def pulp_created(self, pulp_created):
        """Sets the pulp_created of this OpenPGPPublicKeyResponse.

        Timestamp of creation.  # noqa: E501

        :param pulp_created: The pulp_created of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_created = pulp_created

    @property
    def pulp_last_updated(self):
        """Gets the pulp_last_updated of this OpenPGPPublicKeyResponse.  # noqa: E501

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :return: The pulp_last_updated of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_last_updated

    @pulp_last_updated.setter
    def pulp_last_updated(self, pulp_last_updated):
        """Sets the pulp_last_updated of this OpenPGPPublicKeyResponse.

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :param pulp_last_updated: The pulp_last_updated of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_last_updated = pulp_last_updated

    @property
    def fingerprint(self):
        """Gets the fingerprint of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The fingerprint of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: str
        """
        return self._fingerprint

    @fingerprint.setter
    def fingerprint(self, fingerprint):
        """Sets the fingerprint of this OpenPGPPublicKeyResponse.


        :param fingerprint: The fingerprint of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                fingerprint is not None and len(fingerprint) > 64):
            raise ValueError("Invalid value for `fingerprint`, length must be less than or equal to `64`")  # noqa: E501

        self._fingerprint = fingerprint

    @property
    def created(self):
        """Gets the created of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The created of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this OpenPGPPublicKeyResponse.


        :param created: The created of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: datetime
        """

        self._created = created

    @property
    def user_ids(self):
        """Gets the user_ids of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The user_ids of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: list[NestedOpenPGPUserIDResponse]
        """
        return self._user_ids

    @user_ids.setter
    def user_ids(self, user_ids):
        """Sets the user_ids of this OpenPGPPublicKeyResponse.


        :param user_ids: The user_ids of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: list[NestedOpenPGPUserIDResponse]
        """

        self._user_ids = user_ids

    @property
    def user_attributes(self):
        """Gets the user_attributes of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The user_attributes of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: list[NestedOpenPGPUserAttributeResponse]
        """
        return self._user_attributes

    @user_attributes.setter
    def user_attributes(self, user_attributes):
        """Sets the user_attributes of this OpenPGPPublicKeyResponse.


        :param user_attributes: The user_attributes of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: list[NestedOpenPGPUserAttributeResponse]
        """

        self._user_attributes = user_attributes

    @property
    def public_subkeys(self):
        """Gets the public_subkeys of this OpenPGPPublicKeyResponse.  # noqa: E501


        :return: The public_subkeys of this OpenPGPPublicKeyResponse.  # noqa: E501
        :rtype: list[NestedOpenPGPPublicSubkeyResponse]
        """
        return self._public_subkeys

    @public_subkeys.setter
    def public_subkeys(self, public_subkeys):
        """Sets the public_subkeys of this OpenPGPPublicKeyResponse.


        :param public_subkeys: The public_subkeys of this OpenPGPPublicKeyResponse.  # noqa: E501
        :type: list[NestedOpenPGPPublicSubkeyResponse]
        """

        self._public_subkeys = public_subkeys

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OpenPGPPublicKeyResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OpenPGPPublicKeyResponse):
            return True

        return self.to_dict() != other.to_dict()
