# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulpcore.configuration import Configuration


class OpenPGPSignatureResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pulp_href': 'str',
        'prn': 'str',
        'pulp_created': 'datetime',
        'pulp_last_updated': 'datetime',
        'issuer': 'str',
        'created': 'datetime',
        'expiration_time': 'str',
        'signers_user_id': 'str',
        'key_expiration_time': 'str',
        'expired': 'bool',
        'key_expired': 'str',
        'signed_content': 'str'
    }

    attribute_map = {
        'pulp_href': 'pulp_href',
        'prn': 'prn',
        'pulp_created': 'pulp_created',
        'pulp_last_updated': 'pulp_last_updated',
        'issuer': 'issuer',
        'created': 'created',
        'expiration_time': 'expiration_time',
        'signers_user_id': 'signers_user_id',
        'key_expiration_time': 'key_expiration_time',
        'expired': 'expired',
        'key_expired': 'key_expired',
        'signed_content': 'signed_content'
    }

    def __init__(self, pulp_href=None, prn=None, pulp_created=None, pulp_last_updated=None, issuer=None, created=None, expiration_time=None, signers_user_id=None, key_expiration_time=None, expired=None, key_expired=None, signed_content=None, local_vars_configuration=None):  # noqa: E501
        """OpenPGPSignatureResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._pulp_href = None
        self._prn = None
        self._pulp_created = None
        self._pulp_last_updated = None
        self._issuer = None
        self._created = None
        self._expiration_time = None
        self._signers_user_id = None
        self._key_expiration_time = None
        self._expired = None
        self._key_expired = None
        self._signed_content = None
        self.discriminator = None

        if pulp_href is not None:
            self.pulp_href = pulp_href
        if prn is not None:
            self.prn = prn
        if pulp_created is not None:
            self.pulp_created = pulp_created
        if pulp_last_updated is not None:
            self.pulp_last_updated = pulp_last_updated
        self.issuer = issuer
        self.created = created
        self.expiration_time = expiration_time
        self.signers_user_id = signers_user_id
        self.key_expiration_time = key_expiration_time
        self.expired = expired
        if key_expired is not None:
            self.key_expired = key_expired
        if signed_content is not None:
            self.signed_content = signed_content

    @property
    def pulp_href(self):
        """Gets the pulp_href of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The pulp_href of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._pulp_href

    @pulp_href.setter
    def pulp_href(self, pulp_href):
        """Sets the pulp_href of this OpenPGPSignatureResponse.


        :param pulp_href: The pulp_href of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._pulp_href = pulp_href

    @property
    def prn(self):
        """Gets the prn of this OpenPGPSignatureResponse.  # noqa: E501

        The Pulp Resource Name (PRN).  # noqa: E501

        :return: The prn of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._prn

    @prn.setter
    def prn(self, prn):
        """Sets the prn of this OpenPGPSignatureResponse.

        The Pulp Resource Name (PRN).  # noqa: E501

        :param prn: The prn of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._prn = prn

    @property
    def pulp_created(self):
        """Gets the pulp_created of this OpenPGPSignatureResponse.  # noqa: E501

        Timestamp of creation.  # noqa: E501

        :return: The pulp_created of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_created

    @pulp_created.setter
    def pulp_created(self, pulp_created):
        """Sets the pulp_created of this OpenPGPSignatureResponse.

        Timestamp of creation.  # noqa: E501

        :param pulp_created: The pulp_created of this OpenPGPSignatureResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_created = pulp_created

    @property
    def pulp_last_updated(self):
        """Gets the pulp_last_updated of this OpenPGPSignatureResponse.  # noqa: E501

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :return: The pulp_last_updated of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_last_updated

    @pulp_last_updated.setter
    def pulp_last_updated(self, pulp_last_updated):
        """Sets the pulp_last_updated of this OpenPGPSignatureResponse.

        Timestamp of the last time this resource was updated. Note: for immutable resources - like content, repository versions, and publication - pulp_created and pulp_last_updated dates will be the same.  # noqa: E501

        :param pulp_last_updated: The pulp_last_updated of this OpenPGPSignatureResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_last_updated = pulp_last_updated

    @property
    def issuer(self):
        """Gets the issuer of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The issuer of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._issuer

    @issuer.setter
    def issuer(self, issuer):
        """Sets the issuer of this OpenPGPSignatureResponse.


        :param issuer: The issuer of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                issuer is not None and len(issuer) > 16):
            raise ValueError("Invalid value for `issuer`, length must be less than or equal to `16`")  # noqa: E501

        self._issuer = issuer

    @property
    def created(self):
        """Gets the created of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The created of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this OpenPGPSignatureResponse.


        :param created: The created of this OpenPGPSignatureResponse.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def expiration_time(self):
        """Gets the expiration_time of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The expiration_time of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._expiration_time

    @expiration_time.setter
    def expiration_time(self, expiration_time):
        """Sets the expiration_time of this OpenPGPSignatureResponse.


        :param expiration_time: The expiration_time of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._expiration_time = expiration_time

    @property
    def signers_user_id(self):
        """Gets the signers_user_id of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The signers_user_id of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._signers_user_id

    @signers_user_id.setter
    def signers_user_id(self, signers_user_id):
        """Sets the signers_user_id of this OpenPGPSignatureResponse.


        :param signers_user_id: The signers_user_id of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._signers_user_id = signers_user_id

    @property
    def key_expiration_time(self):
        """Gets the key_expiration_time of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The key_expiration_time of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._key_expiration_time

    @key_expiration_time.setter
    def key_expiration_time(self, key_expiration_time):
        """Sets the key_expiration_time of this OpenPGPSignatureResponse.


        :param key_expiration_time: The key_expiration_time of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._key_expiration_time = key_expiration_time

    @property
    def expired(self):
        """Gets the expired of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The expired of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: bool
        """
        return self._expired

    @expired.setter
    def expired(self, expired):
        """Sets the expired of this OpenPGPSignatureResponse.


        :param expired: The expired of this OpenPGPSignatureResponse.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and expired is None:  # noqa: E501
            raise ValueError("Invalid value for `expired`, must not be `None`")  # noqa: E501

        self._expired = expired

    @property
    def key_expired(self):
        """Gets the key_expired of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The key_expired of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._key_expired

    @key_expired.setter
    def key_expired(self, key_expired):
        """Sets the key_expired of this OpenPGPSignatureResponse.


        :param key_expired: The key_expired of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._key_expired = key_expired

    @property
    def signed_content(self):
        """Gets the signed_content of this OpenPGPSignatureResponse.  # noqa: E501


        :return: The signed_content of this OpenPGPSignatureResponse.  # noqa: E501
        :rtype: str
        """
        return self._signed_content

    @signed_content.setter
    def signed_content(self, signed_content):
        """Sets the signed_content of this OpenPGPSignatureResponse.


        :param signed_content: The signed_content of this OpenPGPSignatureResponse.  # noqa: E501
        :type: str
        """

        self._signed_content = signed_content

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OpenPGPSignatureResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OpenPGPSignatureResponse):
            return True

        return self.to_dict() != other.to_dict()
